#COMPILE EXE
#OPTIMIZE SIZE

#INCLUDE "WIN32API.INC"

#INCLUDE "pbjpeg.bas"


'===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!
FUNCTION SaveClipboardPic(BYVAL hWnd AS LONG,sFilename AS STRING, iQuality AS LONG) AS LONG
  LOCAL iRet              AS LONG
  LOCAL hBitmap          AS DWORD
  LOCAL dcBitmap          AS DWORD
  LOCAL hDesktop          AS DWORD
  LOCAL bm                AS BITMAP

  hWnd = GetDesktopWindow()
  hDesktop = GetDC(hWnd)
  CALL OpenClipboard(hWnd)
  hBitmap = GetClipboardData(%CF_BITMAP)
  IF (hBitmap= 0) THEN
      MSGBOX "No image found in clipboard.  Press Prt Screen first.",,"SaveClipboardPic Error"
  ELSE
      IF GetObject(hBitmap,LEN(bm),bm) THEN
        dcBitmap = CreateCompatibleDC(hDesktop)
        IF dcBitMap = 0 THEN
            MSGBOX "Failed to get DC",,"SaveClipboardPic Error"
        ELSE
            iRet = SelectObject(dcBitmap, hBitmap)
            IF iRet = 0 OR iRet = %GDI_ERROR THEN MSGBOX "SelectObject Error ",,"SaveClipboardPic Error" + STR$(iRet)
            TRY        'see if we need to remove existing file
              KILL sFilename
            CATCH
            END TRY
            'JPEG routines
            PBJPEG_SetSamplingFrequencies 2, 2, 1, 1, 1, 1
            PBJPEG_SetQuality iQuality
            ' Save to JFIF (JPEG File Interchange Format) file
            PBJPEG_SampleHDC dcBitmap, bm.bmwidth, bm.bmheight, 0, 0
            PBJPEG_SaveFile sFilename
            'PBJPEG_Reset()
            DeleteDC dcBitmap
                                FUNCTION = %TRUE
        END IF
      ELSE
        MSGBOX "Error Getting BM Structure",,"SaveClipboardPic Error"
      END IF

      'Call EmptyClipboard()
  END IF
  CALL CloseClipboard()
  IF hDesktop THEN ReleaseDC hWnd, hDesktop

END FUNCTION
'===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!===!

FUNCTION PBMAIN()
    PBJPEG_Initialize  'must run first to setup JPG routines
    IF SaveClipboardPic(GetDesktopWindow(), "SavedPic.jpg", 90) THEN                'note 90 is the quality of compression (smaller file or better quality)
                MSGBOX "Clipboard saved to SavedPic.jpg",,"Worked"
        END IF
END FUNCTION
